/***************************************************************************
                          dcmenuhandler.cpp  -  description
                             -------------------
    begin                : Don Mai 16 2002
    copyright            : (C) 2002 by Mathias Kster
    email                : mathen@ketelhot.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dcmenuhandler.h"

DCMenuHandler::DCMenuHandler()
{
}

DCMenuHandler::~DCMenuHandler()
{
}

/** */
void DCMenuHandler::InsertMenuItem( QPopupMenu * popupmenu, eMenuItems menuitems, bool enabled )
{
	if(!popupmenu)
	{
		return;
	}

	switch(menuitems)
	{
		case emiSEPARATOR:
				popupmenu->insertSeparator();
				break;
		case emiDOWNLOAD:
				popupmenu->insertItem( tr("Download"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiDOWNLOAD_TO:
				popupmenu->insertItem( tr("Download To"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiDOWNLOAD_AS:
				popupmenu->insertItem( tr("Download As"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiBROWSE_USER_FILES:
				popupmenu->insertItem( tr("Browse User Files"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiPRIVATE_CHAT:
				popupmenu->insertItem( tr("Private Chat"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiKICK:
				popupmenu->insertItem( tr("Kick"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiFORCE_MOVE:
				popupmenu->insertItem( tr("Force Move"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiUPDATE_USER:
				popupmenu->insertItem( tr("Update User"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiCONNECT:
				popupmenu->insertItem( tr("Connect"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiDISCONNECT:
				popupmenu->insertItem( tr("Disconnect"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiRELOAD_USERLIST:
				popupmenu->insertItem( tr("Reload Userlist"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiCONNECT_TO_HUB:
				popupmenu->insertItem( tr("Connect To Hub"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiADD:
				popupmenu->insertItem( tr("Add"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiADD_BOOKMARK:
				popupmenu->insertItem( tr("Add Bookmark"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiEDIT:
				popupmenu->insertItem( tr("Edit"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiEDIT_BOOKMARK:
				popupmenu->insertItem( tr("Edit Bookmark"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiREMOVE:
				popupmenu->insertItem( tr("Remove"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiCLOSE_TRANSFER:
				popupmenu->insertItem( tr("Close Transfer"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiINFO:
				popupmenu->insertItem( tr("Info"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiTRY_CONNECT:
				popupmenu->insertItem( tr("Try Connect"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiREMOVE_TRANSFER_QUEUE:
				popupmenu->insertItem( tr("Remove from Queue"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiREMOVE_TRANSFER_QUEUE_DISK:
				popupmenu->insertItem( tr("Remove Transfer from Queue and Disk"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiADD_USER_SLOT:
				popupmenu->insertItem( tr("Add Slot to User"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiADD_PERMANENT_USER_SLOT:
				popupmenu->insertItem( tr("Add Permanent Slot to User"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiREMOVE_USER_SLOT:
				popupmenu->insertItem( tr("Remove Slot from user"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiSAVE_QUEUE:
				popupmenu->insertItem( tr("Save Queue"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiUPDATE_SERVER:
				popupmenu->insertItem( tr("Update Server"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiUPDATE_ALL_SERVER:
				popupmenu->insertItem( tr("Update all Server"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiCHANGE_TRANSFER_RATE:
				popupmenu->insertItem( tr("Change Transfer-Rate"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiCOPY_ROW_TO_CLIPBOARD:
				popupmenu->insertItem( tr("Copy row to Clipboard"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		case emiCOPY_COLUMN_TO_CLIPBOARD:
				popupmenu->insertItem( tr("Copy column to Clipboard"), menuitems );
				popupmenu->setItemEnabled( menuitems, enabled );
				break;
		default:
				break;
	}
}

/** */
void DCMenuHandler::InsertMenuItem( QPopupMenu * popupmenu, QString text, bool enabled )
{
	if(!popupmenu)
	{
		return;
	}

	popupmenu->insertItem( text, emiUSER_CAPTION );
	popupmenu->setItemEnabled( emiUSER_CAPTION, enabled );
}

